﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Telerik.Windows.Controls;
using Telerik.Windows.Controls.Data.PropertyGrid;
using Telerik.Windows.Persistence;

namespace SaveProperties
{
    public partial class MainWindow : Window
    {
        Dictionary<string, object> propertyValueDictionary = new Dictionary<string, object>();
        public MainWindow()
        {
            InitializeComponent();
            var employee =  new Employee()
            {
                FirstName = "Sarah",
                LastName = "Blake",
                Occupation = "Supplied Manager",
                IsMarried = true,
                Salary = 3500,
                Age = 35,
            };

            foreach (PropertyInfo propertyInfo in employee.GetType().GetProperties())
            {
               propertyValueDictionary.Add(propertyInfo.Name, propertyInfo.GetValue(employee,null));
            }          

            this.PropertyGrid.Item = employee;
        }

        private void RadButton_Click(object sender, RoutedEventArgs e)
        {
           // (this.PropertyGrid.Item as Employee).RestoreBackUp();
        }

        private void InitButton_Click(object sender, RoutedEventArgs e)
        {
            var propertyGridField = (sender as RadButton).ParentOfType<PropertyGridField>();
            if(propertyGridField != null)
            {
                var propertyDefinition = propertyGridField.DataContext as PropertyDefinition;
                PropertyInfo propertyInfo =  this.PropertyGrid.Item.GetType().GetProperty(propertyDefinition.SourceProperty.Name);

                propertyInfo.SetValue(this.PropertyGrid.Item, propertyValueDictionary[propertyInfo.Name]);
            }
        }

        private void RefreshDataButton_Click(object sender, RoutedEventArgs e)
        {

        }        
    }
}
